#ifndef __PRIMITIVETYPE_H
#define __PRIMITIVETYPE_H

#include "Type.h"
#include "Property.h"
#include <string>
#include <iostream>

    class PrimitiveType : public Type
    {
    public:
        PrimitiveType(std::string TypeName);
        virtual ~PrimitiveType();
        virtual void WriteConstructorDefinition(Property* property, std::ostream& os);
        virtual void WriteStringLoadCall(std::string strParam, std::ostream& os);
        virtual void WriteToHtmlStringCall(std::string strParam, std::ostream& os);
        
        // XML
        virtual void WriteXmlLoadCall(std::string xmlName, Property* property, std::ostream& os);
        virtual void WriteXmlSaveCall(std::string xmlName, Property* property, std::ostream& os);
        
        // HTTP / HTML
        virtual void WriteHtmlShowCall(Property* property, std::ostream& os);
        virtual void WriteHtmlFormCall(Property* property, std::ostream& os);
        virtual void WriteHttpPostLoadCall(Property* property, std::ostream& os);
    };

    class StringType : public PrimitiveType
    {
    public:
        static StringType stringType;
        StringType();
        virtual ~StringType();
        virtual void WriteToHtmlStringCall(std::string strParam, std::ostream& os);
    };
    
    class IntType : public PrimitiveType
    {
    public:
        static IntType intType;
        IntType();
        virtual ~IntType();
        virtual void WriteStringLoadCall(std::string strParam, std::ostream& os);
    };

    class FloatType : public PrimitiveType
    {
    public:
        static FloatType floatType;
        FloatType();
        virtual ~FloatType();
        virtual void WriteStringLoadCall(std::string strParam, std::ostream& os);
    };
    
    class DateType : public PrimitiveType
    {
    public:
        static DateType dateType;
        DateType();
        virtual ~DateType();
        virtual void WriteStringLoadCall(std::string strParam, std::ostream& os);
        virtual void WriteToHtmlStringCall(std::string strParam, std::ostream& os);
    };
    
    /*
    class ImageType : public PrimitiveType
    {
    public:
        static ImageType imageType;
        ImageType();
        virtual ~ImageType();
        // XML
        virtual void WriteXmlLoadCall(std::string xmlName, Property* property, std::ostream& os);
        virtual void WriteXmlSaveCall(std::string xmlName, Property* property, std::ostream& os);
        // HTTP / HTML
        virtual void WriteHtmlShowCall(Property* property, std::ostream& os);
        virtual void WriteHtmlFormCall(Property* property, std::ostream& os);
        virtual void WriteHttpPostLoadCall(Property* property, std::ostream& os);
    };
    */
    
#endif
