 
#ifndef __TYPE_H
#define __TYPE_H

#include <vector>
#include <map>
#include <string>

    class Property;
    
    class Type
    {
    public:
        static std::map<std::string, Type*> AllTypes;
        static std::vector<Type*> AllTypesOrdered;
        std::string TypeName;
        
        Type(std::string TypeName);
        virtual ~Type();
        virtual void WriteConstructorDefinition(Property* property, std::ostream& os) = 0;
        
        // XML
        virtual void WriteXmlLoadCall(std::string xmlName, Property* property, std::ostream& os) = 0;
        virtual void WriteXmlSaveCall(std::string xmlName, Property* property, std::ostream& os) = 0;

        // HTTP / HTML
        virtual void WriteHtmlShowCall(Property* property, std::ostream& os) = 0;
        virtual void WriteHtmlFormCall(Property* property, std::ostream& os) = 0;
        virtual void WriteHttpPostLoadCall(Property* property, std::ostream& os) = 0;
    };

#endif
