 
#include "PrimitiveType.h"
using namespace std;


PrimitiveType::PrimitiveType(string TypeName)
    : Type(TypeName)
{
}
PrimitiveType::~PrimitiveType()
{
}
void PrimitiveType::WriteConstructorDefinition(Property* property, ostream& os)
{
}
void PrimitiveType::WriteXmlSaveCall(string xmlName, Property* property, ostream& os)
{
    os << "        $" << xmlName << "->addAttribute(\"" << property->Name << "\", $this->" << property->Name <<  ");" << endl;
}
void PrimitiveType::WriteXmlLoadCall(string xmlName, Property* property, ostream& os)
{
    os << "        $this->" << property->Name << " = ";
    WriteStringLoadCall("(string)($" + xmlName + "['" + property->Name + "'])", os);
    os << ";" << endl;
}
void PrimitiveType::WriteHttpPostLoadCall(Property* property, ostream& os)
{
    os << "        $this->" << property->Name << " = ";
    WriteStringLoadCall("$post['" + property->Name + "']", os);
    os << ";" << endl;
}
void PrimitiveType::WriteHtmlShowCall(Property* property, ostream& os)
{
    os << "        echo str_repeat('  ', $indent+1) . \"<div class='primitive'><div class='" << property->type->TypeName << "' id='" << property->Name << "'><div class='caption'>" << property->Caption << "</div>\" . ";
    WriteToHtmlStringCall("$this->" + property->Name, os);
    os <<  " . \"</div></div>\\n\";" << endl;
}
void PrimitiveType::WriteHtmlFormCall(Property* property, ostream& os)
{
    os << "        echo str_repeat('  ', $indent+1) . \"<div class='primitive'><div class='" << property->type->TypeName << "' id='" << property->Name
       << "'><div class='caption'>" << property->Caption << "</div>"
       << "<input type=\\\"text\\\" name=\\\"\" . $prefix . \"[" << property->Name << "]\\\" value=\\\"\" . ";
    WriteToHtmlStringCall("$this->" + property->Name, os);
    os << " . \"\\\"/></div></div>\\n\";" << endl;
}
void PrimitiveType::WriteToHtmlStringCall(string strParam, ostream& os)
{
    os << strParam;
}
void PrimitiveType::WriteStringLoadCall(string strParam, ostream& os)
{
    os << strParam;
}




StringType::StringType()
    : PrimitiveType("string")
{
}
StringType::~StringType()
{
}
void StringType::WriteToHtmlStringCall(string strParam, ostream& os)
{
    os << "htmlspecialchars(" << strParam << ")";
}




IntType::IntType()
    : PrimitiveType("int")
{
}
IntType::~IntType()
{
}
void IntType::WriteStringLoadCall(string strParam, ostream& os)
{
    os << "intval(" << strParam << ")";
}




FloatType::FloatType()
    : PrimitiveType("float")
{
}
FloatType::~FloatType()
{
}
void FloatType::WriteStringLoadCall(string strParam, ostream& os)
{
    os << "floatval(" << strParam << ")";
}




DateType::DateType()
    : PrimitiveType("date")
{
}
DateType::~DateType()
{
}
void DateType::WriteStringLoadCall(string strParam, ostream& os)
{
    os << "strtotime(" << strParam << ")";
}
void DateType::WriteToHtmlStringCall(string strParam, ostream& os)
{
    os << "date('d.m.Y', " << strParam << ")";
}



StringType StringType::stringType;
IntType IntType::intType;
FloatType FloatType::floatType;
DateType DateType::dateType;
