<?php
class Angebot extends Object
{
    public /*string*/ $beschreibung;
    public /*Variante*/ $varianten;

    public function __construct()
    {
        parent::__construct();
        $this->varianten = array();
    }

    public function RemoteProcedureCall($prefix, $str)
    {
        if(parent::RemoteProcedureCall($prefix, $str))
            return true;
        if($str == $prefix . '[varianten].Add()')
            {array_push($this->varianten, new Variante()); return true;}
        $variantenCounter = 0;
        foreach($this->varianten as &$variantenIterator)
        {
            $variantenSelector = $prefix . '[varianten][' . $variantenCounter . ']';
            if(substr($str, strlen($variantenSelector)) == $variantenSelector)
                return $variantenIterator->RemoteProcedureCall($variantenSelector, $str);
            $variantenCounter++;
        }
        return false;
    }

    public function fromXml(&$xml)
    {
        parent::fromXml($xml);
        $this->beschreibung = (string)($xml['beschreibung']);
        foreach($xml->varianten as $variantenXmlNode)
        {
            $variantenTypeName = (string)$variantenXmlNode['type'];
            $variantenTemp = new $variantenTypeName;
            $variantenTemp->fromXml($variantenXmlNode);
            array_push($this->varianten, $variantenTemp);
        }
    }

    public function toXml(&$xml)
    {
        parent::toXml($xml);
        $xml->addAttribute("beschreibung", $this->beschreibung);
        foreach($this->varianten as $variantenIterator)
        {
            $variantenXmlNode = $xml->addChild('varianten');
            $variantenIterator->toXml($variantenXmlNode);
        }
    }

    public function htmlView($indent, $divid)
    {
        if($divid != null)
        {
            echo str_repeat('  ', $indent) . "<div class='composed'><div class='Angebot' id='$divid'>";
            echo "<div class='caption'>$divid</div>\n";
        }
        parent::htmlView($indent, null);
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='string' id='beschreibung'><div class='caption'>beschreibung</div>" . htmlspecialchars($this->beschreibung) . "</div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='array' id='varianten'><div class='caption'>varianten</div>\n";
        $variantenCounter = 0;
        foreach($this->varianten as $variantenIterator)
            $variantenIterator->htmlView($indent+2, 'varianten');
        echo str_repeat('  ', $indent+1) . "</div>\n";
        if($divid != null)
            echo str_repeat('  ', $indent) . "</div></div>\n";
    }

    public function htmlForm($prefix, $indent, $divid)
    {
        if($divid != null)
        {
            echo str_repeat('  ', $indent) . "<div class='composed'><div class='Angebot' id='$divid'>\n";
            echo str_repeat('  ', $indent+1) . "<div class='caption'>$divid</div>\n";
        }
        parent::htmlForm($prefix, $indent, null);
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='string' id='beschreibung'><div class='caption'>beschreibung</div><input type=\"text\" name=\"" . $prefix . "[beschreibung]\" value=\"" . htmlspecialchars($this->beschreibung) . "\"/></div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='array' id='varianten'><div class='caption'>varianten</div>\n";
        $variantenCounter = 0;
        foreach($this->varianten as $variantenIterator)
            $variantenIterator->htmlForm($prefix . '[varianten][' . $variantenCounter++ . ']' , $indent+2, 'varianten');
        echo str_repeat('  ', $indent+2) . "<button type='submit' name='rpc' value='" . $prefix . "[varianten].Add()'>Add</button>\n";
        echo str_repeat('  ', $indent+1) . "</div>\n";
        if($divid != null)
            echo str_repeat('  ', $indent) . "</div></div>\n";
    }

    public function fromHttpPost(&$post)
    {
        parent::fromHttpPost($post);
        $this->beschreibung = $post['beschreibung'];
        $variantenCounter = 0;
        foreach($this->varianten as $variantenIterator)
            $variantenIterator->fromHttpPost($post['varianten'][$variantenCounter++]);
    }
}
?>