<?php
class AngebotsGruppe extends Object
{
    public /*string*/ $name;
    public /*Angebot*/ $angebote;

    public function __construct()
    {
        parent::__construct();
        $this->angebote = array();
    }

    public function RemoteProcedureCall($prefix, $str)
    {
        if(parent::RemoteProcedureCall($prefix, $str))
            return true;
        if($str == $prefix . '[angebote].Add()')
            {array_push($this->angebote, new Angebot()); return true;}
        $angeboteCounter = 0;
        foreach($this->angebote as &$angeboteIterator)
        {
            $angeboteSelector = $prefix . '[angebote][' . $angeboteCounter . ']';
            if(substr($str, strlen($angeboteSelector)) == $angeboteSelector)
                return $angeboteIterator->RemoteProcedureCall($angeboteSelector, $str);
            $angeboteCounter++;
        }
        return false;
    }

    public function fromXml(&$xml)
    {
        parent::fromXml($xml);
        $this->name = (string)($xml['name']);
        foreach($xml->angebote as $angeboteXmlNode)
        {
            $angeboteTypeName = (string)$angeboteXmlNode['type'];
            $angeboteTemp = new $angeboteTypeName;
            $angeboteTemp->fromXml($angeboteXmlNode);
            array_push($this->angebote, $angeboteTemp);
        }
    }

    public function toXml(&$xml)
    {
        parent::toXml($xml);
        $xml->addAttribute("name", $this->name);
        foreach($this->angebote as $angeboteIterator)
        {
            $angeboteXmlNode = $xml->addChild('angebote');
            $angeboteIterator->toXml($angeboteXmlNode);
        }
    }

    public function htmlView($indent, $divid)
    {
        if($divid != null)
        {
            echo str_repeat('  ', $indent) . "<div class='composed'><div class='AngebotsGruppe' id='$divid'>";
            echo "<div class='caption'>$divid</div>\n";
        }
        parent::htmlView($indent, null);
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='string' id='name'><div class='caption'>name</div>" . htmlspecialchars($this->name) . "</div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='array' id='angebote'><div class='caption'>angebote</div>\n";
        $angeboteCounter = 0;
        foreach($this->angebote as $angeboteIterator)
            $angeboteIterator->htmlView($indent+2, 'angebote');
        echo str_repeat('  ', $indent+1) . "</div>\n";
        if($divid != null)
            echo str_repeat('  ', $indent) . "</div></div>\n";
    }

    public function htmlForm($prefix, $indent, $divid)
    {
        if($divid != null)
        {
            echo str_repeat('  ', $indent) . "<div class='composed'><div class='AngebotsGruppe' id='$divid'>\n";
            echo str_repeat('  ', $indent+1) . "<div class='caption'>$divid</div>\n";
        }
        parent::htmlForm($prefix, $indent, null);
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='string' id='name'><div class='caption'>name</div><input type=\"text\" name=\"" . $prefix . "[name]\" value=\"" . htmlspecialchars($this->name) . "\"/></div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='array' id='angebote'><div class='caption'>angebote</div>\n";
        $angeboteCounter = 0;
        foreach($this->angebote as $angeboteIterator)
            $angeboteIterator->htmlForm($prefix . '[angebote][' . $angeboteCounter++ . ']' , $indent+2, 'angebote');
        echo str_repeat('  ', $indent+2) . "<button type='submit' name='rpc' value='" . $prefix . "[angebote].Add()'>Add</button>\n";
        echo str_repeat('  ', $indent+1) . "</div>\n";
        if($divid != null)
            echo str_repeat('  ', $indent) . "</div></div>\n";
    }

    public function fromHttpPost(&$post)
    {
        parent::fromHttpPost($post);
        $this->name = $post['name'];
        $angeboteCounter = 0;
        foreach($this->angebote as $angeboteIterator)
            $angeboteIterator->fromHttpPost($post['angebote'][$angeboteCounter++]);
    }
}
?>