<?php
class Kategorie extends Object
{
    public /*string*/ $name;
    public /*Kategorie*/ $unterkategorien;
    public /*AngebotsGruppe*/ $angebotsgruppen;

    public function __construct()
    {
        parent::__construct();
        $this->unterkategorien = array();
        $this->angebotsgruppen = array();
    }

    public function RemoteProcedureCall($prefix, $str)
    {
        if(parent::RemoteProcedureCall($prefix, $str))
            return true;
        if($str == $prefix . '[unterkategorien].Add()')
            {array_push($this->unterkategorien, new Kategorie()); return true;}
        $unterkategorienCounter = 0;
        foreach($this->unterkategorien as &$unterkategorienIterator)
        {
            $unterkategorienSelector = $prefix . '[unterkategorien][' . $unterkategorienCounter . ']';
            if(substr($str, strlen($unterkategorienSelector)) == $unterkategorienSelector)
                return $unterkategorienIterator->RemoteProcedureCall($unterkategorienSelector, $str);
            $unterkategorienCounter++;
        }
        if($str == $prefix . '[angebotsgruppen].Add()')
            {array_push($this->angebotsgruppen, new AngebotsGruppe()); return true;}
        $angebotsgruppenCounter = 0;
        foreach($this->angebotsgruppen as &$angebotsgruppenIterator)
        {
            $angebotsgruppenSelector = $prefix . '[angebotsgruppen][' . $angebotsgruppenCounter . ']';
            if(substr($str, strlen($angebotsgruppenSelector)) == $angebotsgruppenSelector)
                return $angebotsgruppenIterator->RemoteProcedureCall($angebotsgruppenSelector, $str);
            $angebotsgruppenCounter++;
        }
        return false;
    }

    public function fromXml(&$xml)
    {
        parent::fromXml($xml);
        $this->name = (string)($xml['name']);
        foreach($xml->unterkategorien as $unterkategorienXmlNode)
        {
            $unterkategorienTypeName = (string)$unterkategorienXmlNode['type'];
            $unterkategorienTemp = new $unterkategorienTypeName;
            $unterkategorienTemp->fromXml($unterkategorienXmlNode);
            array_push($this->unterkategorien, $unterkategorienTemp);
        }
        foreach($xml->angebotsgruppen as $angebotsgruppenXmlNode)
        {
            $angebotsgruppenTypeName = (string)$angebotsgruppenXmlNode['type'];
            $angebotsgruppenTemp = new $angebotsgruppenTypeName;
            $angebotsgruppenTemp->fromXml($angebotsgruppenXmlNode);
            array_push($this->angebotsgruppen, $angebotsgruppenTemp);
        }
    }

    public function toXml(&$xml)
    {
        parent::toXml($xml);
        $xml->addAttribute("name", $this->name);
        foreach($this->unterkategorien as $unterkategorienIterator)
        {
            $unterkategorienXmlNode = $xml->addChild('unterkategorien');
            $unterkategorienIterator->toXml($unterkategorienXmlNode);
        }
        foreach($this->angebotsgruppen as $angebotsgruppenIterator)
        {
            $angebotsgruppenXmlNode = $xml->addChild('angebotsgruppen');
            $angebotsgruppenIterator->toXml($angebotsgruppenXmlNode);
        }
    }

    public function htmlView($indent, $divid)
    {
        if($divid != null)
        {
            echo str_repeat('  ', $indent) . "<div class='composed'><div class='Kategorie' id='$divid'>";
            echo "<div class='caption'>$divid</div>\n";
        }
        parent::htmlView($indent, null);
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='string' id='name'><div class='caption'>name</div>" . htmlspecialchars($this->name) . "</div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='array' id='unterkategorien'><div class='caption'>unterkategorien</div>\n";
        $unterkategorienCounter = 0;
        foreach($this->unterkategorien as $unterkategorienIterator)
            $unterkategorienIterator->htmlView($indent+2, 'unterkategorien');
        echo str_repeat('  ', $indent+1) . "</div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='array' id='angebotsgruppen'><div class='caption'>angebotsgruppen</div>\n";
        $angebotsgruppenCounter = 0;
        foreach($this->angebotsgruppen as $angebotsgruppenIterator)
            $angebotsgruppenIterator->htmlView($indent+2, 'angebotsgruppen');
        echo str_repeat('  ', $indent+1) . "</div>\n";
        if($divid != null)
            echo str_repeat('  ', $indent) . "</div></div>\n";
    }

    public function htmlForm($prefix, $indent, $divid)
    {
        if($divid != null)
        {
            echo str_repeat('  ', $indent) . "<div class='composed'><div class='Kategorie' id='$divid'>\n";
            echo str_repeat('  ', $indent+1) . "<div class='caption'>$divid</div>\n";
        }
        parent::htmlForm($prefix, $indent, null);
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='string' id='name'><div class='caption'>name</div><input type=\"text\" name=\"" . $prefix . "[name]\" value=\"" . htmlspecialchars($this->name) . "\"/></div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='array' id='unterkategorien'><div class='caption'>unterkategorien</div>\n";
        $unterkategorienCounter = 0;
        foreach($this->unterkategorien as $unterkategorienIterator)
            $unterkategorienIterator->htmlForm($prefix . '[unterkategorien][' . $unterkategorienCounter++ . ']' , $indent+2, 'unterkategorien');
        echo str_repeat('  ', $indent+2) . "<button type='submit' name='rpc' value='" . $prefix . "[unterkategorien].Add()'>Add</button>\n";
        echo str_repeat('  ', $indent+1) . "</div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='array' id='angebotsgruppen'><div class='caption'>angebotsgruppen</div>\n";
        $angebotsgruppenCounter = 0;
        foreach($this->angebotsgruppen as $angebotsgruppenIterator)
            $angebotsgruppenIterator->htmlForm($prefix . '[angebotsgruppen][' . $angebotsgruppenCounter++ . ']' , $indent+2, 'angebotsgruppen');
        echo str_repeat('  ', $indent+2) . "<button type='submit' name='rpc' value='" . $prefix . "[angebotsgruppen].Add()'>Add</button>\n";
        echo str_repeat('  ', $indent+1) . "</div>\n";
        if($divid != null)
            echo str_repeat('  ', $indent) . "</div></div>\n";
    }

    public function fromHttpPost(&$post)
    {
        parent::fromHttpPost($post);
        $this->name = $post['name'];
        $unterkategorienCounter = 0;
        foreach($this->unterkategorien as $unterkategorienIterator)
            $unterkategorienIterator->fromHttpPost($post['unterkategorien'][$unterkategorienCounter++]);
        $angebotsgruppenCounter = 0;
        foreach($this->angebotsgruppen as $angebotsgruppenIterator)
            $angebotsgruppenIterator->fromHttpPost($post['angebotsgruppen'][$angebotsgruppenCounter++]);
    }
}
?>